#include "macros.h"

namespace fd {
namespace cli {

const char*
get_exit_message(ExitCode code)
{
    if (code == ExitCode::CLI_PARSE_ERROR) {
        return "Invalid command line arguments. Use -h to print the available options.";
    } else if (code == ExitCode::INTERNAL_ERROR) {
        return "Unknown internal error.";
    } else if (code == ExitCode::INPUT_ERROR) {
        return "Invalid input file.";
    }
    return NULL;
}

}
}
