#ifndef HMAX_DEAD_END_HEURISTIC_H
#define HMAX_DEAD_END_HEURISTIC_H

#include "cp_heuristic.h"
#include "../../types.h"

#include <memory>
#include <vector>

namespace fd {
namespace sas_task {
class SASTask;
}
namespace heuristics {
namespace classic {

class HmaxDeadEndHeuristic : public ClassicalPlanningHeuristic {
public:
    HmaxDeadEndHeuristic(
            const std::shared_ptr<sas_task::SASTask> task);

    virtual EvaluationResult evaluate(const StateData& state) override;
private:
    using Counter = unsigned int;
    using Fact    = unsigned int;

    std::vector<std::vector<Fact> > m_fact_map;
    std::vector<int> m_num_preconditions;
    std::vector<std::vector<Counter> > m_counter_preconditions;
    std::vector<std::vector<Fact> > m_counter_effects;
    std::vector<bool> m_in_goal;
    unsigned m_num_facts;
    unsigned m_num_goals;
};

}
}
}

#endif
