#ifndef HEURISTIC_EVALUATION_RESULT_H
#define HEURISTIC_EVALUATION_RESULT_H

#include "../types.h"

#include <memory>

namespace fd {
namespace heuristics {

struct EvaluationResult {
    EvaluationResult(ValueType value);
    EvaluationResult(bool dead, ValueType value);
    EvaluationResult(const EvaluationResult& other) = default;
    EvaluationResult(EvaluationResult&& other) = default;
    ~EvaluationResult() = default;

    EvaluationResult& operator=(const EvaluationResult& other) = default;
    EvaluationResult& operator=(EvaluationResult&& other) = default;

    bool operator==(const EvaluationResult& other) const;

    bool dead;
    ValueType value;
};

}
}

#endif
