#ifndef SAS_FACT_PAIR_H
#define SAS_FACT_PAIR_H

namespace fd {
namespace sas_task {

struct FactPair
{
    int var;
    int value;

    FactPair(int var, int value)
        : var(var), value(value)
    {
    }

    bool
    operator<(const FactPair& other) const
    {
        return var < other.var || (var == other.var && value < other.value);
    }

    bool
    operator==(const FactPair& other) const
    {
        return var == other.var && value == other.value;
    }

    bool
    operator!=(const FactPair& other) const
    {
        return var != other.var || value != other.value;
    }

    /*
      This special object represents "no such fact". E.g., functions
      that search a fact can return "no_fact" when no matching fact is
      found.
    */
    static const FactPair no_fact;
};


}
}

#endif
