#include "types.h"

#include <cmath>

namespace fd {

ValueType
fraction_to_value(int num, int denom)
{
    return (((ValueType) num) / ((ValueType) denom));
}

bool
value_equal(const ValueType& v1, const ValueType& v2)
{
    return std::abs(v1 - v2) < g_epsilon;
}

bool
value_less(const ValueType& v1, const ValueType& v2)
{
    return v1 + g_epsilon < v2;
}

bool
value_greater(const ValueType& v1, const ValueType& v2)
{
    return v1 - g_epsilon > v2;
}

ValueType
value_min(const ValueType& v1, const ValueType& v2)
{
    if (value_greater(v1, v2)) {
        return v2;
    }
    return v1;
}

ValueType
value_max(const ValueType& v1, const ValueType& v2)
{
    if (value_greater(v1, v2)) {
        return v1;
    }
    return v2;
}

ValueType g_epsilon = 1e-6;
const Action UNDEFINED_ACTION = -1;

}
